#include "particle.h"
#include <ctime>

PartikelTest::PartikelTest(QWidget *parent)
   : QWidget(parent)
{
		updateTime = 42;
		TotForce.y=0;
		winSize = 100;
		TotForce.x=0;
		ht = new HookThread;
		ht->start(QThread::IdlePriority);
		desktop = QApplication::desktop();
		resize((int)winSize,(int)winSize);
		setAttribute(Qt::WA_NoSystemBackground);
		setAttribute(Qt::WA_OpaquePaintEvent);
		sUpPos = new QTimer;
		//no windows frame
		setWindowFlags(Qt::FramelessWindowHint | Qt::WindowStaysOnTopHint | Qt::SubWindow);
		#ifdef WIN32
		SetWindowLong(winId(), 
              GWL_EXSTYLE, 
              GetWindowLong(winId(), GWL_EXSTYLE) | WS_EX_LAYERED |WS_EX_TRANSPARENT); 
		#endif
		srand(time(NULL));
		int n_forces=1;
		Vector2d f[1];
		f[0].x=0.0;
		f[0].y=0.2;
		Vector2d vel,pos1,pos2;
		vel.x=3;
		vel.y=2;
		pos1.x=width()/2;
		pos1.y=height()/2;
		pos2.x=width()/2;
		pos2.y=height()/2;
		qDebug("Init");
		Init(250,n_forces,f,Create,vel,pos1,pos2,25,QColor(255,0,0,60),4);
		
		updateTimer = new QBasicTimer();
		updateTimer->start(updateTime, this);
		connect(ht, SIGNAL(mouseHooked()), this, SLOT(getMousePos()));
		connect(sUpPos, SIGNAL(timeout()),this, SLOT(disableUpPos()));
		//connect(timer, SIGNAL(timeout()), this, SLOT(update()));
		createTrayIcon();
}
void PartikelTest::timerEvent(QTimerEvent *e)
{
	if(e->timerId() == updateTimer->timerId())
	{
		upTimer = true;
		update();
	}
}
void PartikelTest::createTrayIcon()
{
	trayIcon = new QSystemTrayIcon(QIcon(":/images/mouse.png"),this);
	
	actionBeenden = new QAction("Beenden",this);
	connect(actionBeenden, SIGNAL(triggered()), qApp, SLOT(quit()));
	
	trayMenu = new QMenu("MausOMeter");
	trayMenu->addAction(actionBeenden);
	
	trayIcon->setContextMenu(trayMenu);
	trayIcon->show();
}
void PartikelTest::getMousePos()
{
	mousePos.x = ht->getMousePos().toPoint().x();
	mousePos.y = ht->getMousePos().toPoint().y();
	QPointF p = ht->getMousePos();
	QPointF po = ht->getOldMousePos();
	pixelsMovedX = po.x()- p.x();
	pixelsMovedY = po.y()- p.y();
	move((int)(mousePos.x-width()/2), (int)(mousePos.y-width()/2));
	if(ht->getLeftClicks() > 0 || ht->getRightClicks() > 0)
	{
		click = true;
		ht->setLeftClicks(0);
		ht->setRightClicks(0);
	}
	if(!click)
	{
		upTimer = true;
		for(int i=0;i<ParticleNum;i++)
		{
			    
			Particles[i].Pos.x+=pixelsMovedX;
			Particles[i].Pos.y+= pixelsMovedY;
			//Particles[i].Vel.x+=pixelsMovedX;
			//Particles[i].Vel.y+= pixelsMovedY;
			if(Particles[i].Pos.y> (winSize-5) || Particles[i].Pos.y< 5)
			{
				Particles[i].Vel.y*=-0.1;
				Particles[i].Pos.y-=pixelsMovedY;
				Particles[i].age=Particles[i].LifeSpan;
			}
			if(Particles[i].Pos.x> (winSize-5) || Particles[i].Pos.x< 5) 
			{
				Particles[i].Vel.x*=-0.1;
				Particles[i].Pos.x-=pixelsMovedX;
				Particles[i].age=Particles[i].LifeSpan;
			}
			
		}
		
		//sUpPos->stop();
		sUpPos->start(50);
		upPos = true;
		update();
	}
}
void PartikelTest::disableUpPos()
{
	upPos = false;
}
void PartikelTest::Init(long num_part,long num_forces, Vector2d Forces[], 
						ParticleType part_type,Vector2d vel, Vector2d pos1,
						Vector2d pos2, int lifespan, QColor color, int size)
{
		Particles = new Particle[num_part]; //num_part is number of particles
		ParticleNum=num_part;
		
	
		for(int i=0;i<num_forces;i++){ //num_forces is number of forces
			
			TotForce.x+=Forces[i].x;
			TotForce.y+=Forces[i].y;
			//qDebug() << QByteArray::number(Forces[i].y);
		}
		Particle_Type=part_type;
		Vel=vel;
		Pos1=pos1;
		Pos2=pos2;
		LifeSpan=lifespan;
		Color=color;
		Size=size;
		
		InitParticles();
}
void PartikelTest::InitParticles()
{
	
	for(int i=0;i<ParticleNum;i++)
		InitParticle(i);
}
void PartikelTest::InitParticle(int i)
{
	Particles[i].Pos.x = rand() % (int)(Pos2.x-Pos1.x+1)+width()/2; //Random X position inside the rectangle
	Particles[i].Pos.y = rand() % (int)(Pos2.y-Pos1.y-1)+width()/2; //Random Y position inside the rectangle
	Particles[i].Vel.x = (rand() % (100+1)/100.0) * Vel.x - Vel.x/2; //Random velocity
	//if(i == 0)
	//	qDebug() << QByteArray::number((rand() % (100+1)/100.0) * Vel.y - Vel.y/2);
	Particles[i].Vel.y = (rand() % (100+1)/100.0) * Vel.y - Vel.y/2; //Random velocity
	Particles[i].color=Color;
	Particles[i].size=Size;
	Particles[i].age=0; //New born baby
	Particles[i].LifeSpan=rand() % (int)(LifeSpan)+1; //Random lifespan
	
}
void PartikelTest::paintEvent(QPaintEvent *e)
{
	if(upTimer)
	{
		//qDebug() << QByteArray::number(winSize);
		QPixmap part(width(), height());
		part.fill(QColor(0,0,0,0));
		QPainter p(&part);
		   //delay(10);
		for(int i=0;i<ParticleNum;i++)
		{
			if(!upPos)
			{
			    if(Particles[i].age >= 0)
				{
				  p.setBrush(Particles[i].color.dark((int)((90/(Particles[i].LifeSpan))*Particles[i].age)+60));
				  p.setPen(Particles[i].color.dark((int)((90/(Particles[i].LifeSpan))*Particles[i].age)+60));
			      //circle((int)Particles[i].Pos.x,(int)Particles[i].Pos.y,Particles[i].size);
				  p.drawEllipse(QRectF((int)Particles[i].Pos.x,(int)Particles[i].Pos.y,
								Particles[i].size,
								Particles[i].size));
				if(i == 0)
					qDebug() << QByteArray::number(LifeSpan);
				  Particles[i].Vel.x+=TotForce.x-pixelsMovedX;
				  Particles[i].Vel.y+=TotForce.y-pixelsMovedY;
				  
				  if(click)
				  {
					if(Particles[i].Pos.x>(mousePos.x+width()/2)+10)
						Particles[i].Vel.x*=+3;
					else if(Particles[i].Pos.x<(mousePos.x+width()/2)+10)
						Particles[i].Vel.x*=-3;
					if(Particles[i].Pos.y>(mousePos.y+width()/2)+10)
						Particles[i].Vel.y*=+3;
					else if(Particles[i].Pos.y<(mousePos.y+width()/2)+10)
						Particles[i].Vel.y*=-3;
				  }
				    Particles[i].Pos.x+=Particles[i].Vel.x;
					  
				    Particles[i].Pos.y+=Particles[i].Vel.y;
				  if(Particles[i].Pos.y> winSize-5 || Particles[i].Pos.y< 5) Particles[i].Vel.y*=-0.1;
				  if(Particles[i].Pos.x> winSize-5 || Particles[i].Pos.x< 5) Particles[i].Vel.x*=-0.1;
				  Particles[i].age++;
			      if(Particles[i].age > Particles[i].LifeSpan)
				  {
				     if(Particle_Type == Create) {
						InitParticle(i);
				     }
				     else 
					 {
						Particles[i].age = -1;
				     } 
				  }
	
				}
				
			}
			else
			{
			    if(Particles[i].age >= 0)
				{
				  p.setBrush(Particles[i].color.dark((int)((90/(Particles[i].LifeSpan))*Particles[i].age)+60));
				  p.setPen(Particles[i].color.dark((int)((90/(Particles[i].LifeSpan))*Particles[i].age)+60));
			      //circle((int)Particles[i].Pos.x,(int)Particles[i].Pos.y,Particles[i].size);
				  p.drawEllipse(QRectF((int)Particles[i].Pos.x,(int)Particles[i].Pos.y,
								Particles[i].size,
								Particles[i].size));
				  
				  Particles[i].Vel.x+=TotForce.x/updateTime;
				  Particles[i].Vel.y+=TotForce.y/updateTime;
				  
				  if(click)
				  {
					if(Particles[i].Pos.x>(mousePos.x-width()/2)+10)
						Particles[i].Vel.x*=+3;
					else if(Particles[i].Pos.x<(mousePos.x-width()/2)+10)
						Particles[i].Vel.x*=-3;
					if(Particles[i].Pos.y>(mousePos.y-width()/2)+10)
						Particles[i].Vel.y*=+3;
					else if(Particles[i].Pos.y<(mousePos.y-width()/2)+10)
						Particles[i].Vel.y*=-3;
				  }
				      Particles[i].Pos.x+=Particles[i].Vel.x/updateTime;
				      Particles[i].Pos.y+=Particles[i].Vel.y/updateTime;
					  
				  if(Particles[i].Pos.y> winSize-5 || Particles[i].Pos.y< 5) Particles[i].Vel.y*=-0.1;
				  if(Particles[i].Pos.x> winSize-5 || Particles[i].Pos.x< 5) Particles[i].Vel.x*=-0.1;
				  Particles[i].age+=1;
			      if(Particles[i].age > Particles[i].LifeSpan)
				  {
				     if(Particle_Type == Create) {
						InitParticle(i);
				     }
				     else 
					 {
						Particles[i].age = 1;
				     } 
				  }

				}
			}
			
		}
		if(!upPos)
			pixelsMovedX = pixelsMovedY = 0;
		upPos = false;
		if(click)
			click = false;
		p.end();
		
		
		#ifdef WIN32
		updateAlpha(part);
		#else
		setMask(part.mask());
		p.begin(this);
		p.drawPixmap(0,0,part);
		p.end();
		upTimer = false;
		#endif
	}
}

#ifdef WIN32
void PartikelTest::updateAlpha(QPixmap p)
{
	
	//this makes the alpha blending work. just gdi funktions and a conversation from QPixmap to HBITMAP. not really interresting
	
		
	 HBITMAP oldBitmap;
	 HBITMAP hBitmap;	
     SIZE size;
     size.cx = p.width();
     size.cy = p.height();
     HDC screenDc = GetDC(NULL);
     POINT pointSource;
     pointSource.x = 0;
     pointSource.y = 0; 
     POINT topPos;
     topPos.x = x();
     topPos.y = y();	
     HDC memDc = CreateCompatibleDC(screenDc);
     BLENDFUNCTION blend;
     blend.BlendOp             = AC_SRC_OVER;
     blend.BlendFlags          = 0;
     blend.SourceConstantAlpha = 255;
     blend.AlphaFormat         = AC_SRC_ALPHA;
	 hBitmap = p.toWinHBITMAP(QPixmap::PremultipliedAlpha);  // grab a GDI handle from this GDI+ bitmap
	 oldBitmap = (HBITMAP)SelectObject(memDc, hBitmap);
	 
	UpdateLayeredWindow(winId(), screenDc,  &topPos,  &size, memDc,  &pointSource, 0, &blend, ULW_ALPHA);
	
	// 
	ReleaseDC( NULL, screenDc);
	if (hBitmap != NULL)
	{
		SelectObject(memDc, oldBitmap);
		//DeleteObject(hBitmap); // The documentation says that we have to use the Windows.DeleteObject... but since there is no such method I use the normal DeleteObject from Win32 GDI and it's working fine without any resource leak.
		DeleteObject(hBitmap);
	}
	DeleteDC(memDc); 
}
#endif
