#ifndef LIST1
#define LIST1
#include <QtGui>
#include "hookthread.h"
#ifdef WIN32
#define _WIN32_WINNT 0x0500
#define WINVER 0x0500
#include <windows.h>
#endif

class PartikelTest : public QWidget
{
      Q_OBJECT
      
public:
       PartikelTest(QWidget *parent = 0);
	   
	   
		enum ParticleType { Create,Update };

		struct Vector2d{
		double x;
		double y;
		};

		struct Particle {
		Vector2d Pos; //Position of the particle
		Vector2d Vel; //Velocity of the particle
		double age; //Current age of the particle
		double LifeSpan; //Age after which the particle dies
		QColor color;
		double size;
		};
		
	    void Init(long num_part,long num_forces, Vector2d Forces[], 
						ParticleType part_type,Vector2d vel, Vector2d pos1,
						Vector2d pos2, int lifespan, QColor color, int size);
		

		void InitParticles();
		void InitParticle(int i);
		#ifdef WIN32
		void updateAlpha(QPixmap p);
		#endif
public slots:
		void getMousePos();
		void disableUpPos();
private:
		void createTrayIcon();
		void paintEvent(QPaintEvent *e);
		void timerEvent(QTimerEvent *e);
		Particle * Particles;
		long ParticleNum;
		Vector2d Vel;
		Vector2d Pos1;
		Vector2d Pos2;
		//Vector2d * Forces;
		//long ForcesNum;
		Vector2d TotForce;
		double LifeSpan;
		QColor Color;
		double Size;
		ParticleType Particle_Type;
		HookThread *ht;
		QDesktopWidget *desktop;
		Vector2d mousePos;
		QSystemTrayIcon * 	trayIcon;
		QMenu			* 	trayMenu;
		QAction			* 	actionBeenden;
		bool click;
		double pixelsMovedX, pixelsMovedY;
		bool upPos;
		bool upTimer;
		int updateTime;
		QBasicTimer *updateTimer;
		double winSize;
		QTimer *sUpPos;
};
#endif

